<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<link rel="import" href="../../bower_components/neon-animation/animations/scale-up-animation.html">
<link rel="import" href="../../bower_components/paper-button/paper-button.html">
<link rel="import" href="../../bower_components/iron-icons/communication-icons.html">

<dom-module id="dez-login">
  <template>
    <style>
    </style>

    <template is="dom-if" if="[[visible]]">
      <paper-icon-button
        icon="communication:vpn-key"
        title="Help / About"
        on-tap="openLoginDialog"
        style="opacity:0.5;">
      </paper-icon-button>
    </template>
    <paper-dialog id="LoginDialog" entry-animation="scale-up-animation" exit-animation="fade-out-animation" with-backdrop>

      <h2>Log In</h2>
      <template is="dom-if" if="[[error]]">
        <p class="alert-error"><strong>Error:</strong> [[error]]</p>
      </template>
      <paper-input label="Username" value="{{formData.uid}}"></paper-input>
      <paper-input label="Password" type="password" value="{{formData.password}}"></paper-input>
      <div class="buttons">
        <paper-button dialog-dismiss on-tap="_forceDialogToClose">Cancel</paper-button>
        <paper-button dialog-confirm autofocus  on-tap="_postLogin">Log in</paper-button>
      </div>
      <p>
        <a href="mailto:dezrann@algomus.fr?subject=[[_mailSubject]]&body=[[_mailBody]]">
          I would like to have an account
        </a>
      </p>

    </paper-dialog>

    <iron-ajax
      id="loginAjax"
      method="post"
      content-type="application/json"
      handle-as="text"
      on-response="_handleUserResponse"
      on-error="_handleUserError">
    </iron-ajax>

  </template>

  <script>

  class DezLogin extends Polymer.Element {

      static get is() { return 'dez-login'; }

      static get properties() {
        return {
          formData: {
            type: Object,
            value: {}
          },
          error: String,
          authServer: String,
          visible: Boolean
        }
      }

      constructor () {
        super()
        this._mailSubject = "[Dezrann] account request"
        this._mailBody = "Dear%20Algomus%20team%2C%0A%0A" +
          "I%20would%20like%20to%20have%20an%20account%20to%20store%20" +
          "analyses%20for%20my%20research/teaching/...%0A%0A" +
          "Best%20regards%2C%0A%0A"
      }

      openLoginDialog () {
          this.$.LoginDialog.open();
      }

      _forceDialogToClose () {
        // this.$.LoginDialog.close() does not work after login error...!?
        let style = this.$.LoginDialog.getAttribute('style')
        this.$.LoginDialog.setAttribute('style', style + 'display : none;')
      }

      _postLogin() {
        this.$.loginAjax.url = this.authServer + "/authenticate";
        this.$.loginAjax.body = this.formData;
        this.$.loginAjax.generateRequest();
        this._forceDialogToClose()
      }

      _handleUserResponse(event) {
        let response = JSON.parse(event.detail.response);
        if (response.access_token) {
          this.error = '';
          this.dispatchEvent(new CustomEvent("user-logged-in", {
            detail : {
              name: this.formData.uid,
              access_token: response.access_token,
              loggedin: true
            }
          }))
        }
        this.formData = {};
      }

      _handleUserError(event) {
        this.error = event.detail.request.xhr.response;
        this.$.LoginDialog.open();
      }

  }

  window.customElements.define(DezLogin.is, DezLogin);

  </script>
</dom-module>
